import React, { useEffect, useState } from 'react';

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = ".index_segmented-control-container__2yxAR{box-sizing:border-box;direction:ltr;display:table;height:38px;text-align:center;width:170px}.index_segmented-control-container__2yxAR>ul{background:#efeef5;border-radius:30px;display:table-row;display:flex;gap:2px;padding:6px 8px}.index_segmented-control-container__2yxAR>ul>li{align-items:center;background:#fff;border:1px solid;border-right:none;box-sizing:border-box;cursor:pointer;display:table-cell;display:flex;flex:auto;font-size:13px;height:26px;justify-content:center;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;vertical-align:middle}.index_segmented-control-container__2yxAR>ul>li.index_disabled__QIknV{background:#fff!important;color:#717171!important;cursor:not-allowed;opacity:.5}.index_segmented-control-container__2yxAR>ul>li{background:transparent!important;border-color:#efeef5!important;border-radius:30px;color:#717171;min-width:60px;padding:5px 10px}.index_segmented-control-container__2yxAR>ul>li.index_selected__28vKH{background:#fff!important;box-shadow:0 3px 6px 0 rgb(0 0 0/16%);color:#717171!important;font-weight:700}";
var styles = {"segmented-control-container":"index_segmented-control-container__2yxAR","disabled":"index_disabled__QIknV","selected":"index_selected__28vKH"};
styleInject(css_248z);

var _excluded = ["segments", "onChangeSegment"];
/**if no default property is set, the default selected segment is automatically the first encountered  */

var SegmentedControl = function SegmentedControl(_ref) {
  var _segments$find$value, _segments$find;

  var segments = _ref.segments,
      onChangeSegment = _ref.onChangeSegment,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  useEffect(function () {
    var uniqueKeys = new Set(segments.map(function (_ref2) {
      var value = _ref2.value;
      return value;
    }));

    if (uniqueKeys.size !== segments.length) {
      throw new Error('Segments must have unique values');
    }
  }, [segments]);

  var _useState = useState((_segments$find$value = (_segments$find = segments.find(function (s) {
    return s["default"];
  })) == null ? void 0 : _segments$find.value) != null ? _segments$find$value : segments[0].value),
      selectedSegment = _useState[0],
      setSelectedSegment = _useState[1];

  var onChange = function onChange(selectedSegment) {
    setSelectedSegment(selectedSegment);
    onChangeSegment(selectedSegment);
  };

  var renderSegments = function renderSegments() {
    return segments.map(function (segment) {
      if (segment.value === selectedSegment) {
        var _segment$label;

        return React.createElement("li", {
          key: segment.value,
          className: styles['selected'] + " selected"
        }, (_segment$label = segment == null ? void 0 : segment.label) != null ? _segment$label : '');
      }

      if (segment.disabled) {
        var _segment$label2;

        return React.createElement("li", {
          key: segment.value,
          className: styles['disabled'] + " disabled"
        }, (_segment$label2 = segment == null ? void 0 : segment.label) != null ? _segment$label2 : '');
      }

      return React.createElement("li", {
        key: segment.value,
        onClick: function onClick() {
          return onChange(segment.value);
        }
      }, segment.label);
    });
  };

  return React.createElement("div", Object.assign({
    className: styles['segmented-control-container'] + " segmented-control-container"
  }, props), React.createElement("ul", null, renderSegments()));
};

export { SegmentedControl };
//# sourceMappingURL=ios-segmented-control-react.esm.js.map
